-----------------------------
-- Bunch of functions inc! --
-----------------------------
---------------------
-- Binding control --
---------------------
local function PA_Bind(parent, button, clear, state)
	if(clear) then
		ClearOverrideBindings(parent);
	elseif(state == "Enable") then
		if(not button:IsEnabled()) then button:Enable(); end
		SetOverrideBindingClick(parent, true, button:GetText(), parent:GetName());
	end
	if(state == "Disable" and button:IsEnabled()) then button:Disable() end
end

function PA_ButtonControl(Button,state)
	if(Button == "Master") then
		if(state == "Enable") then
			PA_SavedSettings["MasterChecked"] = true
			MinimapButton:Enable()
			if not(PA_Minimap==nil and PA_Minimap:IsShown()) then PA_Minimap:Show(); end
			MillingButton:Enable()
			HerbButton:Enable()
			ProspectingButton:Enable()
			OreButton:Enable()
			EnchantingButton:Enable()
			MaterialButton:Enable()
			if(PA_SavedSettings["MillingChecked"]) then
				MillingChatButton:Enable()
				UIDropDownMenu_EnableDropDown(MillingDropMenu)
				if(PA_SavedSettings["MillingKey"]>=5) then PA_Bind(MillingBB, MillingBind, false, state) end
			end
			if(PA_SavedSettings["HerbChecked"]) then
				HerbChatButton:Enable()
				UIDropDownMenu_EnableDropDown(HerbDropMenu)
				if(PA_SavedSettings["HerbKey"]>=5) then PA_Bind(HerbBB, HerbBind, false, state) end
			end
			if(PA_SavedSettings["ProspectingChecked"]) then
				ProspectingChatButton:Enable()
				UIDropDownMenu_EnableDropDown(ProspectingDropMenu)
				if(PA_SavedSettings["ProspectingKey"]>=5) then PA_Bind(ProspectingBB, ProspectingBind, false, state) end
			end
			if(PA_SavedSettings["OreChecked"]) then
				OreChatButton:Enable()
				UIDropDownMenu_EnableDropDown(OreDropMenu)
				if(PA_SavedSettings["OreKey"]>=5) then PA_Bind(OreBB, OreBind, false, state) end
			end
			if(PA_SavedSettings["EnchantingChecked"]) then
				EnchantingChatButton:Enable()
				UIDropDownMenu_EnableDropDown(EnchantingDropMenu)
				if(PA_SavedSettings["EnchantingKey"]>=5) then PA_Bind(EnchantingBB, EnchantingBind, false, state) end
			end
			if(PA_SavedSettings["MaterialChecked"]) then
				MaterialChatButton:Enable()
				UIDropDownMenu_EnableDropDown(MaterialDropMenu)
				if(PA_SavedSettings["MaterialKey"]>=5) then PA_Bind(MaterialBB, MaterialBind, false, state) end
			end
		end
		if(state == "Disable") then
			PA_SavedSettings["MasterChecked"] = false
			MinimapButton:Disable()
			if(PA_Minimap~=nil and PA_Minimap:IsShown()) then PA_Minimap:Hide(); end
			MillingButton:Disable()
			MillingChatButton:Disable()
			PA_Bind(MillingBB, MillingBind, true, state)
			HerbButton:Disable()
			HerbChatButton:Disable()
			PA_Bind(HerbBB, HerbBind, true, state)
			ProspectingButton:Disable()
			ProspectingChatButton:Disable()
			PA_Bind(ProspectingBB, ProspectingBind, true, state)
			OreButton:Disable()
			OreChatButton:Disable()
			PA_Bind(OreBB, OreBind, true, state)
			EnchantingButton:Disable()
			EnchantingChatButton:Disable()
			PA_Bind(EnchantingBB, EnchantingBind, true, state)
			MaterialButton:Disable()
			MaterialChatButton:Disable()
			PA_Bind(MaterialBB, MaterialBind, true, state)
			UIDropDownMenu_DisableDropDown(MillingDropMenu)
			UIDropDownMenu_DisableDropDown(HerbDropMenu)
			UIDropDownMenu_DisableDropDown(ProspectingDropMenu)
			UIDropDownMenu_DisableDropDown(OreDropMenu)
			UIDropDownMenu_DisableDropDown(EnchantingDropMenu)
			UIDropDownMenu_DisableDropDown(MaterialDropMenu)
		end
	end
	if(Button == "Minimap") then
		if(state == "Enable") then PA_SavedSettings["MinimapChecked"] = true end
		if(state == "Disable") then PA_SavedSettings["MinimapChecked"] = false end
	end
	if(Button == "Milling") then
		if(state == "Enable") then
			PA_SavedSettings["MillingChecked"] = true
			MillingChatButton:Enable()
			UIDropDownMenu_EnableDropDown(MillingDropMenu)
			if(PA_SavedSettings["MillingKey"]>=5) then PA_Bind(MillingBB, MillingBind, false, state) end
		end
		if(state == "Disable") then
			PA_SavedSettings["MillingChecked"] = false
			MillingChatButton:Disable()
			UIDropDownMenu_DisableDropDown(MillingDropMenu)
			PA_Bind(MillingBB, MillingBind, true, state)
		end
		MillingButton:SetChecked(PA_SavedSettings["MillingChecked"])
	end
	if(Button == "Herb") then
		if(state == "Enable") then
			PA_SavedSettings["HerbChecked"] = true
			HerbChatButton:Enable()
			UIDropDownMenu_EnableDropDown(HerbDropMenu)
			if(PA_SavedSettings["HerbKey"]>=5) then PA_Bind(HerbBB, HerbBind, false, true) end
		end
		if(state == "Disable") then
			PA_SavedSettings["HerbChecked"] = false
			HerbChatButton:Disable()
			UIDropDownMenu_DisableDropDown(HerbDropMenu)
			PA_Bind(HerbBB, HerbBind, true, state)
		end
		HerbButton:SetChecked(PA_SavedSettings["HerbChecked"])
	end
	if(Button == "Prospecting") then
		if(state == "Enable") then
			PA_SavedSettings["ProspectingChecked"] = true
			ProspectingChatButton:Enable()
			UIDropDownMenu_EnableDropDown(ProspectingDropMenu)
			if(PA_SavedSettings["ProspectingKey"]>=5) then PA_Bind(ProspectingBB, ProspectingBind, false, state) end
		end
		if(state == "Disable") then
			PA_SavedSettings["ProspectingChecked"] = false
			ProspectingChatButton:Disable()
			UIDropDownMenu_DisableDropDown(ProspectingDropMenu)
			PA_Bind(ProspectingBB, ProspectingBind, true, state)
		end
		ProspectingButton:SetChecked(PA_SavedSettings["ProspectingChecked"])
	end
	if(Button == "Ore") then
		if(state == "Enable") then
			PA_SavedSettings["OreChecked"] = true
			OreChatButton:Enable()
			UIDropDownMenu_EnableDropDown(OreDropMenu)
			if(PA_SavedSettings["OreKey"]>=5) then PA_Bind(OreBB, OreBind, false, state) end
		end
		if(state == "Disable") then
			PA_SavedSettings["OreChecked"] = false
			OreChatButton:Disable()
			UIDropDownMenu_DisableDropDown(OreDropMenu)
			PA_Bind(OreBB, OreBind, true, state)
		end
		OreButton:SetChecked(PA_SavedSettings["OreChecked"])
	end
	if(Button == "Enchanting") then
		if(state == "Enable") then
			PA_SavedSettings["EnchantingChecked"] = true
			EnchantingChatButton:Enable()
			UIDropDownMenu_EnableDropDown(EnchantingDropMenu)
			if(PA_SavedSettings["EnchantingKey"]>=5) then PA_Bind(EnchantingBB, EnchantingBind, false, state) end
		end
		if(state == "Disable") then
			PA_SavedSettings["EnchantingChecked"] = false
			EnchantingChatButton:Disable()
			UIDropDownMenu_DisableDropDown(EnchantingDropMenu)
			PA_Bind(EnchantingBB, EnchantingBind, true, state)
		end
		EnchantingButton:SetChecked(PA_SavedSettings["EnchantingChecked"])
	end
	if(Button == "Material") then
		if(state == "Enable") then
			PA_SavedSettings["MaterialChecked"] = true
			MaterialChatButton:Enable()
			UIDropDownMenu_EnableDropDown(MaterialDropMenu)
			if(PA_SavedSettings["MaterialKey"]>=5) then PA_Bind(MaterialBB, MaterialBind, false, state) end
		end
		if(state == "Disable") then
			PA_SavedSettings["MaterialChecked"] = false
			MaterialChatButton:Disable()
			UIDropDownMenu_DisableDropDown(MaterialDropMenu)
			PA_Bind(MaterialBB, MaterialBind, true, state)
		end
		MaterialButton:SetChecked(PA_SavedSettings["MaterialChecked"])
	end
end
--------------------------
-- Button creator stuff --
--------------------------
local function createCheckbutton(parent, x_loc, y_loc, IDname, displayname, description)
	local checkbutton = CreateFrame("CheckButton", IDname.."CheckButton", parent);
	checkbutton:SetNormalTexture("Interface/Buttons/UI-CheckBox-Up")
	checkbutton:SetPushedTexture("Interface/Buttons/UI-CheckBox-Down")
	checkbutton:SetHighlightTexture("Interface/Buttons/UI-CheckBox-Highlight","ADD")
	checkbutton:SetCheckedTexture("Interface/Buttons/UI-CheckBox-Check")
	checkbutton:SetDisabledCheckedTexture("Interface/Buttons/UI-CheckBox-Check-Disabled")
	checkbutton:SetPoint("TOPLEFT", x_loc, y_loc);
	checkbutton:SetSize(32,32);
	checkbuttonText = checkbutton:CreateFontString("checkbuttonText", "ARTWORK","GameFontHighlight")
	checkbuttonText:SetText(displayname);
	checkbuttonText:SetPoint("LEFT", "$parent", "RIGHT", 0, 1)
	checkbutton:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
		GameTooltip:SetText(displayname, nil, nil, nil, nil, 1);
		GameTooltip:AddLine(description, 1.0, 1.0, 1.0, 1.0);
		GameTooltip:Show();
	end)
	checkbutton:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	return checkbutton;
end

----------------------------
-- FontText creator stuff --
----------------------------
local function createFonttext(parent, x_loc, y_loc, text, fonttemplate)
	local title = parent:CreateFontString(nil, "ARTWORK", fonttemplate);
	title:SetPoint("TOPLEFT", x_loc, y_loc)
	title:SetText(text)
end

--------------------------------
-- DropDownMenu creator stuff --
--------------------------------
function PA_CreateMenu(parent, x_loc, y_loc, IDname, displayname, description)
	local menu = CreateFrame("Button", IDname.."DropMenu", parent, "UIDropDownMenuTemplate")
	
	menu:SetPoint("TOPLEFT", x_loc, y_loc)
	menu:Show()
	
	local function OnClick(self)
		if(menu == MillingDropMenu) then
			PA_SavedSettings["MillingKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			if(PA_SavedSettings["MillingKey"]>=5) then PA_Bind(MillingBB, MillingBind, false, "Enable") else PA_Bind(MillingBB, MillingBind, true, "Disable") end
		end
		if(menu == HerbDropMenu) then
			PA_SavedSettings["HerbKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			if(PA_SavedSettings["HerbKey"]>=5) then PA_Bind(HerbBB, HerbBind, false, "Enable") else PA_Bind(HerbBB, HerbBind, true, "Disable") end
		end
		if(menu == ProspectingDropMenu) then
			PA_SavedSettings["ProspectingKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			if(PA_SavedSettings["ProspectingKey"]>=5) then PA_Bind(ProspectingBB, ProspectingBind, false, "Enable") else PA_Bind(ProspectingBB, ProspectingBind, true, "Disable") end
		end
		if(menu == OreDropMenu) then
			PA_SavedSettings["OreKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			if(PA_SavedSettings["OreKey"]>=5) then PA_Bind(OreBB, OreBind, false, "Enable") else PA_Bind(OreBB, OreBind, true, "Disable") end
		end
		if(menu == EnchantingDropMenu) then
			PA_SavedSettings["EnchantingKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			if(PA_SavedSettings["EnchantingKey"]>=5) then PA_Bind(EnchantingBB, EnchantingBind, false, "Enable") else PA_Bind(EnchantingBB, EnchantingBind, true, "Disable") end
		end
		if(menu == MaterialDropMenu) then
			PA_SavedSettings["MaterialKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			if(PA_SavedSettings["MaterialKey"]>=5) then PA_Bind(MaterialBB, MaterialBind, false, "Enable") else PA_Bind(MaterialBB, MaterialBind, true, "Disable") end
		end
	end
	
	local function init(self, level)
		for _,v in next, {
			"Always",
			"Shift",
			"Ctrl",
			"Alt",
			"Binding"
		}do
			info = UIDropDownMenu_CreateInfo()
			info.text = v
			info.func = OnClick
			UIDropDownMenu_AddButton(info, level)
		end
	end
	
	menu:SetScript('OnEnter', function(self)
		GameTooltip:SetOwner(self,"ANCHOR_TOPRIGHT")
		GameTooltip:SetText(displayname, nil, nil, nil, 1, 1)
		GameTooltip:AddLine(description, 1, 1, 1)
		GameTooltip:Show()
	end)
	menu:SetScript('OnLeave', function(self) GameTooltip:Hide() end)
	
	UIDropDownMenu_Initialize(menu, init)
	UIDropDownMenu_SetWidth(menu, 75);
	UIDropDownMenu_SetButtonWidth(menu, 50)
	UIDropDownMenu_JustifyText(menu, "LEFT")
	
	return menu;
end

--------------------
-- Binding button --
--------------------
function PA_CreateBB(parent, x_loc, y_loc, IDname)
	bindbutton = CreateFrame("Button",IDname.."Bind",parent,"UIPanelButtonTemplate")
	bindbutton:SetPoint("TOPLEFT",x_loc,y_loc)
	bindbutton:SetWidth(100)
	bindbutton:SetHeight(22)
	bindbutton:EnableKeyboard(false)
	bindbutton:SetText("Not Bound")
	
	bindbutton:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self,"ANCHOR_TOP")
		GameTooltip:SetText("Bind a key to show "..IDname.." results", nil, nil, nil, 1, 1)
		GameTooltip:AddLine("|cff00ff00Left-click|r to start binding, click again or press ESCAPE to cancel", 1, 1, 1)
		GameTooltip:AddLine("|cff00ff00Right-click|r to unbind the key", 1, 1, 1)
		GameTooltip:Show()
	end)
	bindbutton:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	
	local idButton = CreateFrame("BUTTON", IDname.."BB");
	local oldKey="";
	bindbutton:SetScript("OnMouseDown", function(self, mouseButton)
		if(self:IsEnabled()) then
			if(mouseButton == "LeftButton") then
				if(self:GetText() == "?") then
					self:EnableKeyboard(false)
					self:SetText(oldKey)
				else
					self:EnableKeyboard(true)
					oldKey = self:GetText()
					self:SetText("?")
				end
			else
				PA_Bind(idButton, self, true, "Enable")
				self:SetText("Not Bound")
				PA_SavedSettings[IDname.."Bind"] = self:GetText()
			end
		end
	end);
	bindbutton:SetScript("OnKeyUp", function(self,key)
		if(self:IsEnabled()) then
			if(IsShiftKeyDown()) then
				self:SetText("SHIFT-"..key)
				self:EnableKeyboard(false)
			end
			if(IsControlKeyDown()) then
				self:SetText("CTRL-"..key)
				self:EnableKeyboard(false)
			end
			if(IsAltKeyDown()) then
				self:SetText("ALT-"..key)
				self:EnableKeyboard(false)
			end
			if(not IsModifierKeyDown()) then
				self:SetText(key)
				self:EnableKeyboard(false)
			end
			if(key == "ESCAPE") then
				self:SetText(oldKey);
				self:EnableKeyboard(false)
			else
				PA_Bind(idButton, self, false, "Enable")
				PA_SavedSettings[IDname.."Bind"] = self:GetText()
			end
		end
	end);
	bindbutton:EnableKeyboard(false)
	
	return bindbutton;
end

-------------------
-- Minimap stuff --
-------------------
function PA_Minimap_Init(parent)
	local menu = CreateFrame("Frame", "PA_Minimap_Menu", parent, "UIDropDownMenuTemplate")
	
	local icons = {
		"", -- space holder
		"Interface\\ICONS\\Ability_miling",
		"Interface\\ICONS\\Trade_herbalism",
		"Interface\\ICONS\\Inv_misc_gem_bloodgem_01",
		"Interface\\ICONS\\Trade_mining",
		"Interface\\ICONS\\Trade_Engraving",
		"Interface\\ICONS\\INV_Enchant_Disenchant"
	}
	
	local function OnClick(self, arg1, _, checked) if not(arg1==Close) and (checked) then PA_ButtonControl(arg1,"Enable") else PA_ButtonControl(arg1,"Disable") end end
	
	local function init(self, level)
		info = UIDropDownMenu_CreateInfo()
		for k,v in next, {
			"Toggle options",
			"Milling",
			"Herb",
			"Prospecting",
			"Ore",
			"Enchanting",
			"Material",
			"Close"
		}do
			if(v=="Toggle options") then
				info.text = v;
				info.isTitle = true;
				info.notCheckable = true;
				UIDropDownMenu_AddButton(info, level)
			else
				if(v=="Close") then
					info.text = v
					info.func = OnClick
					info.arg1 = v
					info.icon = nil
					info.notCheckable = true;
					info.keepShownOnClick = false;
					UIDropDownMenu_AddButton(info, level)
				else
					info.text = v.." results"
					info.func = OnClick
					info.arg1 = v
					info.icon = icons[k]
					info.checked = PA_SavedSettings[v.."Checked"];
					info.isTitle = false;
					info.disabled = false;
					info.isNotRadio = true;
					info.notCheckable = false;
					info.keepShownOnClick = true;
					UIDropDownMenu_AddButton(info, level)
				end
			end
		end
	end
	UIDropDownMenu_Initialize(menu, init, "MENU")
end

local function moveButton(self)
	local centerX, centerY = Minimap:GetCenter()
	local x, y = GetCursorPosition()
	x, y = x / self:GetEffectiveScale() - centerX, y / self:GetEffectiveScale() - centerY
	centerX, centerY = math.abs(x), math.abs(y)
	centerX, centerY = (centerX / math.sqrt(centerX^2 + centerY^2)) * 80, (centerY / sqrt(centerX^2 + centerY^2)) * 80
	centerX = x < 0 and -centerX or centerX
	centerY = y < 0 and -centerY or centerY
	self:ClearAllPoints()
	self:SetPoint("CENTER", centerX, centerY)
	PA_SavedSettings["Minimap_PosX"] = centerX
	PA_SavedSettings["Minimap_PosY"] = centerY
end
local function PA_Minimap_Create()
	PA_Minimap = CreateFrame("Button", "Profession Assistance", Minimap)
	PA_Minimap:SetSize(31, 31)
	PA_Minimap:SetFrameStrata("MEDIUM")
	PA_Minimap:SetPoint("CENTER", PA_SavedSettings["Minimap_PosX"], PA_SavedSettings["Minimap_PosY"])
	PA_Minimap:SetMovable(true)
	PA_Minimap:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")
	
	local overlay = PA_Minimap:CreateTexture(nil, "OVERLAY")
	overlay:SetSize(53, 53)
	overlay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
	overlay:SetPoint("TOPLEFT")
	
	local icon = PA_Minimap:CreateTexture(nil, "ARTWORK")
	icon:SetSize(18.5, 18.5)
	icon:SetTexture("Interface\\ICONS\\INV_Hammer_20")
	icon:SetPoint("TOPLEFT", 7, -5.5)
	
	PA_Minimap:SetScript("OnMouseDown", function(self, button)
		if button == "LeftButton" then
			icon:SetPoint("TOPLEFT", 7, -5.5)
			icon:SetSize(18,18)
			ToggleDropDownMenu(1, nil, PA_Minimap_Menu, self, 0, 0);
		else
			if IsShiftKeyDown() then
				icon:SetPoint("TOPLEFT", 7, -5.5)
				icon:SetSize(18,18)
				self:SetScript("OnUpdate", moveButton)
			else
				icon:SetPoint("TOPLEFT", 7, -5.5)
				icon:SetSize(18,18)
				PA_Panel:Show();
			end
		end
	end)
	PA_Minimap:SetScript("OnMouseUp", function(self)
		self:SetScript("OnUpdate", nil)
		icon:SetSize(18.5,18.5)
		icon:SetPoint("TOPLEFT", 7, -5.5)
	end)
	
	PA_Minimap:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self,"ANCHOR_BOTTOMLEFT")
		GameTooltip:SetText("Profession Assistance", nil, nil, nil, 1, 1)
		GameTooltip:AddLine(" ")
		GameTooltip:AddLine("|cff00ff00Left-click|r to open sub-menu.", 1, 1, 1)
		GameTooltip:AddLine("|cff00ff00Right-click|r to open interface panel.", 1, 1, 1)
		GameTooltip:AddLine("|cff00ff00Shift+Right-click|r to drag this icon.", 1, 1, 1)
		GameTooltip:Show()
	end)
	PA_Minimap:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	
	if(MinimapButton:IsEnabled() and MinimapButton:GetChecked()) then PA_Minimap:Show() else PA_Minimap:Hide() end
	MinimapButton:SetScript("OnClick", function()
		if(MinimapButton:GetChecked()) then
			PA_ButtonControl("Minimap","Enable")
			PA_Minimap:Show()
		else
			PA_ButtonControl("Minimap","Disable")
			PA_Minimap:Hide()
		end
	end);
	
	PA_Minimap_Init(PA_Minimap)
end

--------------------------
-- Interface AddOns tab --
--------------------------
local InterfaceFrame = CreateFrame("Frame")
InterfaceFrame:RegisterEvent("PLAYER_LOGIN");
InterfaceFrame:SetScript("OnEvent", function(self,event,...)
	if(type(PA_SavedSettings) ~= "table") then PA_SavedSettings = {} end
	
	if(PA_SavedSettings["LightmodeChecked"] == nil) then PA_SavedSettings["LightmodeChecked"] = false end
	
	if(PA_SavedSettings["MasterChecked"] == nil) then PA_SavedSettings["MasterChecked"] = true end
	
	if(PA_SavedSettings["MinimapChecked"] == nil) then PA_SavedSettings["MinimapChecked"] = true end
	if(PA_SavedSettings["Minimap_PosX"] == nil) then PA_SavedSettings["Minimap_PosX"] = -78.5 end
	if(PA_SavedSettings["Minimap_PosY"] == nil) then PA_SavedSettings["Minimap_PosY"] = -16 end
	
	if(PA_SavedSettings["MillingChecked"] == nil) then PA_SavedSettings["MillingChecked"] = true end
	if(PA_SavedSettings["MillingChatChecked"] == nil) then PA_SavedSettings["MillingChatChecked"] = true end
	if(PA_SavedSettings["MillingKey"] == nil) then PA_SavedSettings["MillingKey"] = 1 end
	if(PA_SavedSettings["MillingBind"] == nil) then PA_SavedSettings["MillingBind"] = "Not Bound" end
	
	if(PA_SavedSettings["HerbChecked"] == nil) then PA_SavedSettings["HerbChecked"] = true end
	if(PA_SavedSettings["HerbChatChecked"] == nil) then PA_SavedSettings["HerbChatChecked"] = true end
	if(PA_SavedSettings["HerbKey"] == nil) then PA_SavedSettings["HerbKey"] = 1 end
	if(PA_SavedSettings["HerbBind"] == nil) then PA_SavedSettings["HerbBind"] = "Not Bound" end
	
	if(PA_SavedSettings["ProspectingChecked"] == nil) then PA_SavedSettings["ProspectingChecked"] = true end
	if(PA_SavedSettings["ProspectingChatChecked"] == nil) then PA_SavedSettings["ProspectingChatChecked"] = true end
	if(PA_SavedSettings["ProspectingKey"] == nil) then PA_SavedSettings["ProspectingKey"] = 1 end
	if(PA_SavedSettings["ProspectingBind"] == nil) then PA_SavedSettings["ProspectingBind"] = "Not Bound" end
	
	if(PA_SavedSettings["OreChecked"] == nil) then PA_SavedSettings["OreChecked"] = true end
	if(PA_SavedSettings["OreChatChecked"] == nil) then PA_SavedSettings["OreChatChecked"] = true end
	if(PA_SavedSettings["OreKey"] == nil) then PA_SavedSettings["OreKey"] = 1 end
	if(PA_SavedSettings["OreBind"] == nil) then PA_SavedSettings["OreBind"] = "Not Bound" end
	
	if(PA_SavedSettings["EnchantingChecked"] == nil) then PA_SavedSettings["EnchantingChecked"] = true end
	if(PA_SavedSettings["EnchantingChatChecked"] == nil) then PA_SavedSettings["EnchantingChatChecked"] = true end
	if(PA_SavedSettings["EnchantingKey"] == nil) then PA_SavedSettings["EnchantingKey"] = 1 end
	if(PA_SavedSettings["EnchantingBind"] == nil) then PA_SavedSettings["EnchantingBind"] = "Not Bound" end
	
	if(PA_SavedSettings["MaterialChecked"] == nil) then PA_SavedSettings["MaterialChecked"] = true end
	if(PA_SavedSettings["MaterialChatChecked"] == nil) then PA_SavedSettings["MaterialChatChecked"] = true end
	if(PA_SavedSettings["MaterialKey"] == nil) then PA_SavedSettings["MaterialKey"] = 1 end
	if(PA_SavedSettings["MaterialBind"] == nil) then PA_SavedSettings["MaterialBind"] = "Not Bound" end

	------------------
	-- Prompt panel --
	------------------
	
	PA_Panel_Prompt = CreateFrame( "Frame", "PA_Panel_Prompt", UIParent);
	PA_Panel_Prompt:SetFrameStrata("HIGH");
	PA_Panel_Prompt:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32,
		insets = { left = 11, right = 11, top = 12, bottom = 10 }
	});
	PA_Panel_Prompt:SetSize(380,100);
	PA_Panel_Prompt:SetPoint("CENTER");
	
	PA_Panel_Prompt:CreateTexture("$parent_Header", "ARTWORK");
	PA_Panel_Prompt_Header:SetTexture("Interface/DialogFrame/UI-DialogBox-Header");
	PA_Panel_Prompt_Header:SetSize(200,68);
	PA_Panel_Prompt_Header:SetPoint("TOP",0,12);
	PA_Panel_Prompt:CreateFontString("$parent_Header_Text","ARTWORK","GameFontNormal");
	PA_Panel_Prompt_Header_Text:SetPoint("TOP","$parent_Header","TOP",0,-14);
	PA_Panel_Prompt_Header_Text:SetText("Light mode");
	
	createFonttext(PA_Panel_Prompt, 23, -35, "This options requires a reload to work, reload now?", "GameFontHighlight");
	
	PA_Panel_Prompt_Reload = CreateFrame("BUTTON", "$parent_Reload", PA_Panel_Prompt, "UIPanelButtonTemplate");
	PA_Panel_Prompt_Reload:SetPoint("BOTTOMLEFT",22,15);
	PA_Panel_Prompt_Reload:SetWidth(100);
	PA_Panel_Prompt_Reload:SetText("Reload");
	PA_Panel_Prompt_Reload:SetScript("OnClick", function() ReloadUI(); end);
	
	PA_Panel_Prompt_Cancel = CreateFrame("BUTTON", "$parent_Cancel", PA_Panel_Prompt, "UIPanelButtonTemplate");
	PA_Panel_Prompt_Cancel:SetPoint("BOTTOMRIGHT",-22,15);
	PA_Panel_Prompt_Cancel:SetWidth(100);
	PA_Panel_Prompt_Cancel:SetText("Later");
	PA_Panel_Prompt_Cancel:SetScript("OnClick", function() PA_Panel_Prompt:Hide() end);
	
	--Hide it because we don't need to see it straight away!
	PA_Panel_Prompt:Hide();
	
	------------------
	-- Layout panel --
	------------------
	PA_Panel = CreateFrame( "Frame", "PA_Panel", UIParent);
	PA_Panel:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32,
		insets = { left = 11, right = 11, top = 12, bottom = 10 }
	});
	
	PA_Panel:SetFrameStrata("MEDIUM");
	PA_Panel:SetPoint("CENTER",0,0);
	PA_Panel:SetSize(824,568);
	PA_Panel:SetClampedToScreen(true);
	PA_Panel:EnableMouse(true);
	tinsert(UISpecialFrames, PA_Panel:GetName()); -- Makes it able to close when ESC is pressed
	
	PA_Panel:CreateTexture("$parentHeader", "ARTWORK");
	PA_PanelHeader:SetTexture("Interface/DialogFrame/UI-DialogBox-Header");
	PA_PanelHeader:SetSize(300,68);
	PA_PanelHeader:SetPoint("TOP",0,12);
	PA_Panel:CreateFontString("$parentHeaderText","ARTWORK","GameFontNormal");
	PA_PanelHeaderText:SetPoint("TOP","$parentHeader","TOP",0,-14);
	PA_PanelHeaderText:SetText("Profession Assistance");
	
	PA_Panel_Button = CreateFrame("BUTTON", "$parent_Button", PA_Panel, "UIPanelButtonTemplate");
	PA_Panel_Button:SetPoint("BOTTOMRIGHT",-22,15);
	PA_Panel_Button:SetWidth(100);
	PA_Panel_Button:SetText("Close");
	PA_Panel_Button:SetScript("OnClick", function(self) PA_Panel:Hide(); end);
	
	--Hide it because we don't need to see it straight away!
	PA_Panel:Hide();
	
	-- Show the panel with slash command
	SLASH_PA1,SLASH_PA2,SLASH_PA3,SLASH_PA4 = '/PA','/Profession','/Proffesion Assistance','/Profession_Assistance';
	function SlashCmdList.PA(msg, editbox) PA_Panel:Show(); end
	
	-----------------------
	-- Categories frames --
	-----------------------
	PA_Panel_Categories = CreateFrame( "Frame", "$parent_Categories", PA_Panel);
	PA_Panel_Categories:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tileSize = 16, edgeSize = 16,});
	PA_Panel_Categories:SetSize(780,489);
	PA_Panel_Categories:SetPoint("TOPLEFT",22,-40);
	
	-----------------
	-- create tabs --
	-----------------
	PA_Panel_Categories.selectedTab = 1;
	PA_Panel_Categories.subFrames = {};
	PA_Panel_Categories.name = PA_Panel_Categories:GetName();
	
	PA_Panel_Categories.showSubFrame = function(name)
		for index, value in pairs(PA_Panel_Categories.subFrames) do
			if("$parentTab"..index == "$parentTab"..PA_Panel_Categories.selectedTab) then
				_G[value]:Show();
			else _G[value]:Hide(); end
		end
	end

	local setPanel = function(panel,id)
		if(id) then PanelTemplates_SetTab(panel, id); end
		PanelTemplates_UpdateTabs(panel);
		panel.showSubFrame(panel.name.."Tab"..panel.selectedTab);
	end

	local createTab = function(parent, index, name)
		local tab = CreateFrame("Button", "$parentTab"..index, parent, "OptionsFrameTabButtonTemplate");
		tab.id = index;
		tab:SetWidth(50);
		if index == 1 then tab:SetPoint("TOPLEFT",5,24); else tab:SetPoint("LEFT", "$parentTab"..index-1, "RIGHT", -15, 0); end
		tab:HookScript("OnClick", function(self) setPanel(self:GetParent(), self.id); end);
		tab:SetText(string.sub(name,string.len(parent.name)+2));
		PanelTemplates_TabResize(tab);
	end
	
	--create subframes
	local createSubFrame = function(parent,name)
		local subframe = CreateFrame("Frame", "$parent_"..name, parent);
		subframe:SetAllPoints();
		tinsert(parent.subFrames,subframe:GetName());
	end
	
	-- createSubFrame(parent,name)
	createSubFrame(PA_Panel_Categories,"Main");
	createSubFrame(PA_Panel_Categories,"Options");
	PA_Panel_Categories.numTabs = #PA_Panel_Categories.subFrames;
	
	for i = 1, PA_Panel_Categories.numTabs do
		--createTab(Parent,Index,Name)
		createTab(PA_Panel_Categories,i,PA_Panel_Categories.subFrames[i]);
	end
	
	setPanel(PA_Panel_Categories);
	PA_Panel_Categories:HookScript("OnShow",setPanel);
	
	-- Main panel
	
	-- title
	--createFonttext(Parent, Positionx, Positiony, text, template)
	createFonttext(PA_Panel_Categories_Main, 15, -15, "Profession Assistance", "GameFontNormalLarge");
	
	-- content
	createFonttext(PA_Panel_Categories_Main, 20, -80, "|cffffcc00Version|r     "..GetAddOnMetadata("Profession_Assistance","Version"), "GameFontHighlight");
	createFonttext(PA_Panel_Categories_Main, 20, -95, "|cffffcc00Notes|r       "..GetAddOnMetadata("Profession_Assistance","Notes"), "GameFontHighlight");
	createFonttext(PA_Panel_Categories_Main, 20, -125, "|cffffcc00Author|r     "..GetAddOnMetadata("Profession_Assistance","Author"), "GameFontHighlight");
	createFonttext(PA_Panel_Categories_Main, 20, -140, "|cffffcc00Credits|r     "..GetAddOnMetadata("Profession_Assistance","X-Credits"), "GameFontHighlight");
	
	-- Options panel
	
	-- title
	createFonttext(PA_Panel_Categories_Options, 15, -15, "Options", "GameFontNormalLarge");
	
	-- Lightmode
	createFonttext(PA_Panel_Categories_Options, 20, -60, "|cffffcc00Light mode|r", "GameFontNormalLarge");
	LightModeButton = createCheckbutton(PA_Panel_Categories_Options, 15, -80, "LightMode", "Enable Light mode", "Removes all the other options (and prevents errors from appearing.");
	LightModeButton:SetChecked(PA_SavedSettings["LightmodeChecked"]);
	
	LightModeButton:SetScript("OnClick", function()
		PA_Panel_Prompt:Show();
		PA_SavedSettings["LightmodeChecked"] = LightModeButton:GetChecked()
	end);
	
	if not(PA_SavedSettings["LightmodeChecked"]) then
		-- global
		createFonttext(PA_Panel_Categories_Options, 20, -120, "|cffffcc00Global|r", "GameFontNormalLarge");
		-- createCheckbutton(Parent, Positionx, positiony, label, description);
		MasterButton = createCheckbutton(PA_Panel_Categories_Options, 15, -140, "Master", "Enable Master", "Master switch");
		MasterButton:SetChecked(PA_SavedSettings["MasterChecked"]);
		
		-- Minimap
		createFonttext(PA_Panel_Categories_Options, 20, -200, "|cffffcc00Minimap Button|r", "GameFontNormalLarge");
		MinimapButton = createCheckbutton(PA_Panel_Categories_Options, 15, -220, "Minimap", "Enable Minimap", "Toggle minimap button");
		MinimapButton:SetChecked(PA_SavedSettings["MinimapChecked"]);
		
		-- Milling
		createFonttext(PA_Panel_Categories_Options, 420, -60, "|cffffcc00Milling|r", "GameFontNormalLarge")	;
		MillingButton = createCheckbutton(PA_Panel_Categories_Options, 415, -80, "Milling", "Enable Milling", "Toggle milling information on herbs");
		MillingButton:SetChecked(PA_SavedSettings["MillingChecked"]);
		MillingBind = PA_CreateBB(PA_Panel_Categories_Options, 550, -133, "Milling");
		
		MillingChatButton = createCheckbutton(PA_Panel_Categories_Options, 655, -80, "MillingChat", "Enable chat", "Toggle chat information on herbs");
		MillingChatButton:SetChecked(PA_SavedSettings["MillingChatChecked"]);
		
		createFonttext(PA_Panel_Categories_Options, 420, -115, "Shown when: ", "GameFontNormalSmall");
		MillingDropMenu = PA_CreateMenu(PA_Panel_Categories_Options, 405, -130, "Milling", "Appearance control: ","Select one option to make it appear on keyhold or just always");
		UIDropDownMenu_SetSelectedID(MillingDropMenu, PA_SavedSettings["MillingKey"]);
		
		HerbButton = createCheckbutton(PA_Panel_Categories_Options, 415, -170, "Herb", "Enable Herb", "Toggle herb information on pigments");
		HerbButton:SetChecked(PA_SavedSettings["HerbChecked"]);
		HerbBind = PA_CreateBB(PA_Panel_Categories_Options, 550, -223, "Herb");
		
		HerbChatButton = createCheckbutton(PA_Panel_Categories_Options, 655, -170, "HerbChat", "Enable chat", "Toggle chat information on pigments");
		HerbChatButton:SetChecked(PA_SavedSettings["HerbChatChecked"]);
		
		createFonttext(PA_Panel_Categories_Options, 420, -205, "Shown when: ", "GameFontNormalSmall");
		HerbDropMenu = PA_CreateMenu(PA_Panel_Categories_Options, 405, -220, "Herb", "Appearance control: ","Select one option to make it appear on keyhold or just always");
		UIDropDownMenu_SetSelectedID(HerbDropMenu, PA_SavedSettings["HerbKey"]);
		
		-- Prospecting
		createFonttext(PA_Panel_Categories_Options, 20, -280, "|cffffcc00Prospecting|r", "GameFontNormalLarge");
		ProspectingButton = createCheckbutton(PA_Panel_Categories_Options, 15, -300, "Prospecting", "Enable Prospecting", "Toggle prospecting information on ores");
		ProspectingButton:SetChecked(PA_SavedSettings["ProspectingChecked"]);
		ProspectingBind = PA_CreateBB(PA_Panel_Categories_Options, 150, -353, "Prospecting");
		
		ProspectingChatButton = createCheckbutton(PA_Panel_Categories_Options, 255, -300, "ProspectingChat", "Enable chat", "Toggle chat information on ores");
		ProspectingChatButton:SetChecked(PA_SavedSettings["ProspectingChatChecked"]);
		
		createFonttext(PA_Panel_Categories_Options, 20, -335, "Shown when: ", "GameFontNormalSmall");
		ProspectingDropMenu = PA_CreateMenu(PA_Panel_Categories_Options, 5, -350, "Prospecting", "Appearance control", "Select one option to make it appear on keyhold or just always");
		UIDropDownMenu_SetSelectedID(ProspectingDropMenu, PA_SavedSettings["ProspectingKey"]);
		
		OreButton = createCheckbutton(PA_Panel_Categories_Options, 15, -390, "Ore", "Enable Ore", "Toggle ore information on gems");
		OreButton:SetChecked(PA_SavedSettings["OreChecked"]);
		OreBind = PA_CreateBB(PA_Panel_Categories_Options, 150, -448, "Ore");
		
		OreChatButton = createCheckbutton(PA_Panel_Categories_Options, 255, -390, "OreChat", "Enable chat", "Toggle chat information on gems");
		OreChatButton:SetChecked(PA_SavedSettings["OreChatChecked"]);
		
		createFonttext(PA_Panel_Categories_Options, 20, -425, "Shown when: ", "GameFontNormalSmall");
		OreDropMenu = PA_CreateMenu(PA_Panel_Categories_Options, 5, -445, "Ore", "Appearance control", "Select one option to make it appear on keyhold or just always");
		UIDropDownMenu_SetSelectedID(OreDropMenu, PA_SavedSettings["OreKey"]);
		
		-- Enchanting
		createFonttext(PA_Panel_Categories_Options, 420, -280, "|cffffcc00Enchanting|r", "GameFontNormalLarge");
		EnchantingButton = createCheckbutton(PA_Panel_Categories_Options, 415, -300, "Enchanting", "Enable Enchanting", "Toggle enchanting information on gear");
		EnchantingButton:SetChecked(PA_SavedSettings["EnchantingChecked"]);
		EnchantingBind = PA_CreateBB(PA_Panel_Categories_Options, 550, -353, "Enchanting");
		
		EnchantingChatButton = createCheckbutton(PA_Panel_Categories_Options, 655, -300, "EnchantingChat", "Enable chat", "Toggle chat information on gear");
		EnchantingChatButton:SetChecked(PA_SavedSettings["EnchantingChatChecked"]);
		
		createFonttext(PA_Panel_Categories_Options, 420, -335, "Shown when: ", "GameFontNormalSmall");
		EnchantingDropMenu = PA_CreateMenu(PA_Panel_Categories_Options, 405, -350, "Enchanting", "Appearance control", "Select one option to make it appear on keyhold or just always");
		UIDropDownMenu_SetSelectedID(EnchantingDropMenu, PA_SavedSettings["EnchantingKey"])
		
		MaterialButton = createCheckbutton(PA_Panel_Categories_Options, 415, -390, "Material", "Enable Materials", "Toggle gear source information on enchanting materials");
		MaterialButton:SetChecked(PA_SavedSettings["MaterialChecked"]);
		MaterialBind = PA_CreateBB(PA_Panel_Categories_Options, 550, -448, "Material");
		
		MaterialChatButton = createCheckbutton(PA_Panel_Categories_Options, 655, -390, "MaterialChat", "Enable chat", "Toggle chat information on enchanting materials");
		MaterialChatButton:SetChecked(PA_SavedSettings["MaterialChatChecked"]);
		
		createFonttext(PA_Panel_Categories_Options, 420, -425, "Shown when: ", "GameFontNormalSmall");
		MaterialDropMenu = PA_CreateMenu(PA_Panel_Categories_Options, 405, -445, "Material", "Appearance control", "Select one option to make it appear on keyhold or just always");
		UIDropDownMenu_SetSelectedID(MaterialDropMenu, PA_SavedSettings["MaterialKey"]);
		
		-- Minimap button
		PA_Minimap_Create()
		
		---------------------------
		-- Changing settings part --
		---------------------------
		-- Master button
		MasterButton:SetScript("OnClick", function(self) if(self:GetChecked()) then PA_ButtonControl("Master","Enable") else PA_ButtonControl("Master","Disable") end end);
		--PA_ButtonControl(ButtonName,state)
		if(PA_SavedSettings["MasterChecked"])then PA_ButtonControl("Master","Enable") else PA_ButtonControl("Master","Disable") end
		
		-- Milling stuff
		MillingButton:SetScript("OnClick", function(self) if(self:GetChecked()) then PA_ButtonControl("Milling","Enable") else PA_ButtonControl("Milling","Disable") end end);
		if(PA_SavedSettings["MillingKey"]>=5 and MillingButton:GetChecked() and MillingButton:IsEnabled()) then MillingBind:Enable() else MillingBind:Disable() end
		
		MillingChatButton:SetScript("OnClick", function(self) PA_SavedSettings["MillingChatChecked"] = self:GetChecked() end);
		if(MillingButton:GetChecked() and MillingButton:IsEnabled()) then MillingChatButton:Enable() else MillingChatButton:Disable() end
		
		MillingBind:SetText(PA_SavedSettings["MillingBind"])
		if(PA_SavedSettings["MillingBind"]~="Not Bound" and MillingBind:IsEnabled()) then PA_Bind(MillingBB, MillingBind, false, "Enable")end
		
		
		HerbButton:SetScript("OnClick", function(self) if(self:GetChecked()) then PA_ButtonControl("Herb","Enable") else PA_ButtonControl("Herb","Disable") end end);
		if(PA_SavedSettings["HerbKey"]>=5 and HerbButton:GetChecked() and HerbButton:IsEnabled()) then HerbBind:Enable() else HerbBind:Disable() end
		
		HerbChatButton:SetScript("OnClick", function(self) PA_SavedSettings["HerbChatChecked"] = self:GetChecked() end);
		if(HerbButton:GetChecked() and HerbButton:IsEnabled()) then HerbChatButton:Enable() else HerbChatButton:Disable() end
		
		HerbBind:SetText(PA_SavedSettings["HerbBind"])
		if(PA_SavedSettings["HerbBind"]~="Not Bound" and HerbBind:IsEnabled()) then PA_Bind(HerbBB, HerbBind, false, "Enable") end
		
		
		-- Prospecting stuff
		ProspectingButton:SetScript("OnClick", function(self) if(self:GetChecked()) then PA_ButtonControl("Prospecting","Enable") else PA_ButtonControl("Prospecting","Disable") end end);
		if(PA_SavedSettings["ProspectingKey"]>=5 and ProspectingButton:GetChecked() and ProspectingButton:IsEnabled()) then ProspectingBind:Enable() else ProspectingBind:Disable() end
		
		ProspectingChatButton:SetScript("OnClick", function(self) PA_SavedSettings["ProspectingChatChecked"] = self:GetChecked() end);
		if(ProspectingButton:GetChecked() and ProspectingButton:IsEnabled()) then ProspectingChatButton:Enable() else ProspectingChatButton:Disable() end
		
		ProspectingBind:SetText(PA_SavedSettings["ProspectingBind"])
		if(PA_SavedSettings["ProspectingBind"]~="Not Bound" and ProspectingBind:IsEnabled()) then PA_Bind(ProspectingBB, ProspectingBind, false, "Enable") end
		
		
		OreButton:SetScript("OnClick", function(self) if(self:GetChecked()) then PA_ButtonControl("Ore","Enable") else PA_ButtonControl("Ore","Disable") end end);
		if(PA_SavedSettings["OreKey"]>=5 and OreButton:GetChecked() and OreButton:IsEnabled()) then OreBind:Enable() else OreBind:Disable() end
		
		OreChatButton:SetScript("OnClick", function(self) PA_SavedSettings["OreChatChecked"] = self:GetChecked() end);
		if(OreButton:GetChecked() and OreButton:IsEnabled()) then OreChatButton:Enable() else OreChatButton:Disable() end
		
		OreBind:SetText(PA_SavedSettings["OreBind"])
		if(PA_SavedSettings["OreBind"]~="Not Bound" and OreBind:IsEnabled()) then PA_Bind(OreBB, OreBind, false, "Enable") end
		
		
		-- Enchanting stuff
		EnchantingButton:SetScript("OnClick", function() if(EnchantingButton:GetChecked()) then PA_ButtonControl("Enchanting","Enable") else PA_ButtonControl("Enchanting","Disable") end end);
		if(PA_SavedSettings["EnchantingKey"]>=5 and EnchantingButton:GetChecked() and EnchantingButton:IsEnabled()) then EnchantingBind:Enable() else EnchantingBind:Disable() end
		
		EnchantingChatButton:SetScript("OnClick", function(self) PA_SavedSettings["EnchantingChatChecked"] = self:GetChecked() end);
		if(EnchantingButton:GetChecked() and EnchantingButton:IsEnabled()) then EnchantingChatButton:Enable() else EnchantingChatButton:Disable() end
		
		EnchantingBind:SetText(PA_SavedSettings["EnchantingBind"])
		if(EnchantingBind:GetText()~="Not Bound" and EnchantingBind:IsEnabled()) then PA_Bind(EnchantingBB, EnchantingBind, false, "Enable") end
		
		
		MaterialButton:SetScript("OnClick", function() if(MaterialButton:GetChecked()) then PA_ButtonControl("Material","Enable") else PA_ButtonControl("Material","Disable") end end);
		if(PA_SavedSettings["MaterialKey"]>=5 and MaterialButton:GetChecked() and MaterialButton:IsEnabled()) then MaterialBind:Enable() else MaterialBind:Disable() end
		
		MaterialChatButton:SetScript("OnClick", function(self) PA_SavedSettings["MaterialChatChecked"] = self:GetChecked() end);
		if(MaterialButton:GetChecked() and MaterialButton:IsEnabled()) then MaterialChatButton:Enable() else MaterialChatButton:Disable() end
		
		MaterialBind:SetText(PA_SavedSettings["MaterialBind"])
		if(PA_SavedSettings["MaterialBind"]~="Not Bound" and MaterialBind:IsEnabled()) then PA_Bind(MaterialBB, MaterialBind, false, "Enable") end
	end
end);